#include "game.h"
#include "bird.h"

Bird bird;
Gamestate gamestate;

SceneManager* Manager = SceneManager::GetInstance(); 

Game::Game()
{
    
}

void Game::Init(int width, int height, std::string title) 
{
    

    SetWindowSize(width, height);
    SetWindowTitle(title.c_str());
    gamestate = Gamestate::game;
    bird.Init(); 

}

Game::~Game()
{

} 

bool Game::GameShouldClose() const
{
    if (gamestate == Gamestate::pause && IsKeyPressed(KEY_ESCAPE) )  // 정지상태일 때에만 ESC로 종료
        return true;

    if (gamestate == Gamestate::game) 
    {
        return false; 
    }
    
    return false;
}

void Game::Tick()
{
    
    BeginDrawing();
    Update();
    Draw();
    EndDrawing(); 

}

void Game::Update()
{
    // Update
    switch (gamestate)
    {
        case Gamestate::pause :    // 정지로직 
        
            if (IsKeyPressed(KEY_UP)) gamestate = Gamestate::game; 

            if (gamestate == Gamestate::pause && IsKeyPressed(KEY_ESCAPE) ) Manager->gameExit = true;   // 정지상태일때, ESC 누르면 종료
            break;

        case Gamestate::game:   // 게임로직

            SetExitKey(KEY_F9);
            bird.Update();
            if (IsKeyPressed(KEY_UP)) bird.Jump(); 

            if (IsKeyPressed(KEY_ESCAPE)) gamestate = Gamestate::pause;
            break; 

        default: 

        break;
    }
}

void Game::Draw()
{ 
    // Draw
    switch(gamestate)
    {
        case Gamestate::pause :   // 정지화면 그리기 
            ClearBackground(BLACK); 
            DrawRectangle(GetScreenWidth() / 2 - 180, GetScreenHeight() / 2 - 60, 360, 120, DARKBROWN);
            DrawText("Press Arrow Up  if you continue", GetScreenWidth() / 2 - 160, GetScreenHeight() / 2 -20, 20, MAGENTA);
            DrawText("Press ESC to Exit Game", GetScreenWidth() / 2 - 160, GetScreenHeight() / 2 + 10, 20, MAGENTA);
            // DrawText(TextFormat("Exit : %S", sceneManager->gameExit), GetScreenWidth() - 200, 60, 10, DARKGRAY);
            bird.Draw();
            break;

        case Gamestate::game:  // 게임화면 그리기 
            ClearBackground(BLACK); 
            DrawText("Pause : Press ESC", GetScreenWidth() - 200, 20, 20, DARKGRAY);
            bird.Draw();
            // DrawText(TextFormat("Current Scene : %d", scene), GetScreenWidth() - 200, 40, 20, DARKGRAY);
            // DrawText(TextFormat("Exit : %s", sceneManager->gameExit), GetScreenWidth() - 200, 60, 10, DARKGRAY);
            break;
    }
}
