#include "menu.h"
#include "gui.h"
SceneManager* menuManager = SceneManager::GetInstance();  

// GUI button; 
GUI button[3];

// 텍스처 로드하기 
// NOTE: Textures MUST be loaded after Window initialization (OpenGL context is required)
Texture2D birdImage;        // Texture loading;  

void Menu::Init(int width, int height, std::string title)
{
    // 창의 사이즈 및 이름을 설정하기 
    SetWindowSize(width, height);
    SetWindowTitle(title.c_str());

   // 각 버튼 선언하기 
   button[0].Init(GetScreenWidth() - 200, GetScreenHeight() - 200, 180, 40, "Game Start");   // 게임 시작 버튼
   button[1].Init(GetScreenWidth() - 200, GetScreenHeight() - 140, 180, 40, "Score Board");  // 점수판 버튼
   button[2].Init(GetScreenWidth() - 200, GetScreenHeight() - 80, 180, 40, "Exit Game");   // 게임 종료 버튼

   birdImage = LoadTexture("Assets/birddrawing.png");        // Texture loading
}

void Menu::Tick()   // 기본적인 루프
{
    BeginDrawing();    // 레이라이브 기본 함수이다. 
    Update();
    Draw();
    EndDrawing();  // 레이라이브 기본 함수이다. 
}

Menu::Menu()
{
}

Menu::~Menu()
{
    UnloadTexture(birdImage);       // Texture unloading
}

void Menu::Update()
{
    for (int i = 0; i < 3; i++)
    {
        button[i].Update();
    }

    // 버튼 선택하고 마우스 입력한 신호 받기 
    if (IsMouseButtonPressed(MOUSE_BUTTON_LEFT) && button[0].GetChecked()) menuManager->scene = Scene::game; 

    if (IsMouseButtonPressed(MOUSE_BUTTON_LEFT) && button[1].GetChecked())  menuManager->scene = Scene::scoreScene; 

    if (IsMouseButtonPressed(MOUSE_BUTTON_LEFT) && button[2].GetChecked())  menuManager->gameExit = true;
    
}

void Menu::Draw()
{
    ClearBackground(BLACK);
    DrawText("Flappy Bird Menu!", GetScreenWidth() / 2 - 160, GetScreenHeight() / 2  - 40, 40, DARKBROWN); 

    DrawTexture(birdImage, GetScreenWidth() / 2, 80, WHITE);   // 텍스쳐 그리기. 여기에서는 새 그림 

   // 버튼 그리기 
   for (int i = 0; i < 3;i++)
   {
        button[i].Draw();
   }
}
